<?php

namespace Sio\Module\TourismInsuranceBundle\Model\ErvSoap;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'agentType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\AgentType',
            'agentWarningType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\AgentWarningType',
            'ProlongationRqType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\ProlongationRqType',
            'ProlongationRpType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\ProlongationRpType',
            'insConditionsType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\InsConditionsType',
            'productLineUrls' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\ProductLineUrls',
            'insConditionsRqType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\InsConditionsRqType',
            'linkType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\LinkType',
            'localisationType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\LocalisationType',
            'customerType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\CustomerType',
            'offersRpType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\OffersRpType',
            'offer' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\Offer',
            'service' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\Service',
            'acceptedPayments' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\AcceptedPayments',
            'cc' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\Cc',
            'acceptedCard' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\AcceptedCard',
            'bank' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\Bank',
            'agencyCollection' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\AgencyCollection',
            'benefits' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\Benefits',
            'offersRqType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\OffersRqType',
            'differingAccountHolderType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\DifferingAccountHolderType',
            'paymentType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\PaymentType',
            'productSpecType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\ProductSpecType',
            'providerDataType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\ProviderDataType',
            'serviceType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\ServiceType',
            'servicePremium' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\ServicePremium',
            'serviceRenewalPremium' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\ServiceRenewalPremium',
            'systemRqType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\SystemRqType',
            'systemRpType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\SystemRpType',
            'tariffsType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\TariffsType',
            'tariff' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\Tariff',
            'travelType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\TravelType',
            'time' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\Time',
            'totalTripCost' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\TotalTripCost',
            'bankPaymentType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\BankPaymentType',
            'ccPaymentType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\CcPaymentType',
            'ccValidType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\CcValidType',
            'DescriptionURLType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\DescriptionURLType',
            'preContractualInformationItemType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\PreContractualInformationItemType',
            'preContractualInformationType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\PreContractualInformationType',
            'destinationType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\DestinationType',
            'coveredTravelersType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\CoveredTravelersType',
            'coveredTravelerType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\CoveredTravelerType',
            'personType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\PersonType',
            'personNameType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\PersonNameType',
            'searchTravelersType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\SearchTravelersType',
            'extensionsType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\ExtensionsType',
            'extensionType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\ExtensionType',
            'searchTravelerType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\SearchTravelerType',
            'indCoverageType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\IndCoverageType',
            'tripCost' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\TripCost',
            'coveredLuggage' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\CoveredLuggage',
            'requestOffer' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\RequestOffer',
            'responseOffer' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\ResponseOffer',
            'requestPreContractualInformation' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\RequestPreContractualInformation',
            'responsePreContractualInformation' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\ResponsePreContractualInformation',
            'requestBooking' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\RequestBooking',
            'policyAsLink' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\PolicyAsLink',
            'responseBooking' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\ResponseBooking',
            'policy' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\Policy',
            'totalPremium' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\TotalPremium',
            'totalRenewalPremium' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\TotalRenewalPremium',
            'policyAttachments' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\PolicyAttachments',
            'thanx' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\Thanx',
            'requestCancellation' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\RequestCancellation',
            'responseCancellation' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\ResponseCancellation',
            'systemErrorContainerType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\SystemErrorContainerType',
            'userErrorContainerType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\UserErrorContainerType',
            'userErrorType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\UserErrorType',
            'errorType' => '\\Sio\\Module\\TourismInsuranceBundle\\Model\\ErvSoap\\StructType\\ErrorType',
        );
    }
}
