<?php

namespace Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for agencyCollection StructType
 * @subpackage Structs
 */
class AgencyCollection extends AbstractStructBase
{
    /**
     * The accepted
     * Meta informations extracted from the WSDL
     * - documentation: Flag, dass kennzeichnet, ob Agenturinkasso als Zahlungsmittel akzeptiert wird.
     * - use: required
     * @var bool
     */
    public $accepted;
    /**
     * Constructor method for agencyCollection
     * @uses AgencyCollection::setAccepted()
     * @param bool $accepted
     */
    public function __construct($accepted = null)
    {
        $this
            ->setAccepted($accepted);
    }
    /**
     * Get accepted value
     * @return bool
     */
    public function getAccepted()
    {
        return $this->accepted;
    }
    /**
     * Set accepted value
     * @param bool $accepted
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\AgencyCollection
     */
    public function setAccepted($accepted = null)
    {
        // validation for constraint: boolean
        if (!is_null($accepted) && !is_bool($accepted)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($accepted)), __LINE__);
        }
        $this->accepted = $accepted;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\AgencyCollection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
