<?php

namespace Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for benefits StructType
 * Meta informations extracted from the WSDL
 * - documentation: service benefits [Leistungsbeschreibung]
 * @subpackage Structs
 */
class Benefits extends AbstractStructBase
{
    /**
     * The descriptionURL
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\DescriptionURLType[]
     */
    public $descriptionURL;
    /**
     * Constructor method for benefits
     * @uses Benefits::setDescriptionURL()
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\DescriptionURLType[] $descriptionURL
     */
    public function __construct(array $descriptionURL = array())
    {
        $this
            ->setDescriptionURL($descriptionURL);
    }
    /**
     * Get descriptionURL value
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\DescriptionURLType[]|null
     */
    public function getDescriptionURL()
    {
        return $this->descriptionURL;
    }
    /**
     * Set descriptionURL value
     * @throws \InvalidArgumentException
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\DescriptionURLType[] $descriptionURL
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\Benefits
     */
    public function setDescriptionURL(array $descriptionURL = array())
    {
        foreach ($descriptionURL as $benefitsDescriptionURLItem) {
            // validation for constraint: itemType
            if (!$benefitsDescriptionURLItem instanceof \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\DescriptionURLType) {
                throw new \InvalidArgumentException(sprintf('The descriptionURL property can only contain items of \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\DescriptionURLType, "%s" given', is_object($benefitsDescriptionURLItem) ? get_class($benefitsDescriptionURLItem) : gettype($benefitsDescriptionURLItem)), __LINE__);
            }
        }
        $this->descriptionURL = $descriptionURL;
        return $this;
    }
    /**
     * Add item to descriptionURL value
     * @throws \InvalidArgumentException
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\DescriptionURLType $item
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\Benefits
     */
    public function addToDescriptionURL(\Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\DescriptionURLType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\DescriptionURLType) {
            throw new \InvalidArgumentException(sprintf('The descriptionURL property can only contain items of \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\DescriptionURLType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->descriptionURL[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\Benefits
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
