<?php

namespace Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for cc StructType
 * @subpackage Structs
 */
class Cc extends AbstractStructBase
{
    /**
     * The accepted
     * Meta informations extracted from the WSDL
     * - documentation: Flag, dass kennzeichnet, ob generell Kreditkarten als Zahlungsmittel akzeptiert wird.
     * - use: required
     * @var bool
     */
    public $accepted;
    /**
     * The acceptedCard
     * Meta informations extracted from the WSDL
     * - maxOccurs: 11
     * - minOccurs: 0
     * @var \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\AcceptedCard[]
     */
    public $acceptedCard;
    /**
     * Constructor method for cc
     * @uses Cc::setAccepted()
     * @uses Cc::setAcceptedCard()
     * @param bool $accepted
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\AcceptedCard[] $acceptedCard
     */
    public function __construct($accepted = null, array $acceptedCard = array())
    {
        $this
            ->setAccepted($accepted)
            ->setAcceptedCard($acceptedCard);
    }
    /**
     * Get accepted value
     * @return bool
     */
    public function getAccepted()
    {
        return $this->accepted;
    }
    /**
     * Set accepted value
     * @param bool $accepted
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\Cc
     */
    public function setAccepted($accepted = null)
    {
        // validation for constraint: boolean
        if (!is_null($accepted) && !is_bool($accepted)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($accepted)), __LINE__);
        }
        $this->accepted = $accepted;
        return $this;
    }
    /**
     * Get acceptedCard value
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\AcceptedCard[]|null
     */
    public function getAcceptedCard()
    {
        return $this->acceptedCard;
    }
    /**
     * Set acceptedCard value
     * @throws \InvalidArgumentException
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\AcceptedCard[] $acceptedCard
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\Cc
     */
    public function setAcceptedCard(array $acceptedCard = array())
    {
        foreach ($acceptedCard as $ccAcceptedCardItem) {
            // validation for constraint: itemType
            if (!$ccAcceptedCardItem instanceof \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\AcceptedCard) {
                throw new \InvalidArgumentException(sprintf('The acceptedCard property can only contain items of \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\AcceptedCard, "%s" given', is_object($ccAcceptedCardItem) ? get_class($ccAcceptedCardItem) : gettype($ccAcceptedCardItem)), __LINE__);
            }
        }
        $this->acceptedCard = $acceptedCard;
        return $this;
    }
    /**
     * Add item to acceptedCard value
     * @throws \InvalidArgumentException
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\AcceptedCard $item
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\Cc
     */
    public function addToAcceptedCard(\Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\AcceptedCard $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\AcceptedCard) {
            throw new \InvalidArgumentException(sprintf('The acceptedCard property can only contain items of \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\AcceptedCard, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->acceptedCard[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\Cc
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
