<?php

namespace Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for coveredTravelersType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Daten der zu versichernden Personen (Reisenden). | Container for covered travelers
 * @subpackage Structs
 */
class CoveredTravelersType extends AbstractStructBase
{
    /**
     * The coveredTraveler
     * Meta informations extracted from the WSDL
     * - maxOccurs: 100
     * @var \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredTravelerType[]
     */
    public $coveredTraveler;
    /**
     * Constructor method for coveredTravelersType
     * @uses CoveredTravelersType::setCoveredTraveler()
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredTravelerType[] $coveredTraveler
     */
    public function __construct(array $coveredTraveler = array())
    {
        $this
            ->setCoveredTraveler($coveredTraveler);
    }
    /**
     * Get coveredTraveler value
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredTravelerType[]|null
     */
    public function getCoveredTraveler()
    {
        return $this->coveredTraveler;
    }
    /**
     * Set coveredTraveler value
     * @throws \InvalidArgumentException
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredTravelerType[] $coveredTraveler
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredTravelersType
     */
    public function setCoveredTraveler(array $coveredTraveler = array())
    {
        foreach ($coveredTraveler as $coveredTravelersTypeCoveredTravelerItem) {
            // validation for constraint: itemType
            if (!$coveredTravelersTypeCoveredTravelerItem instanceof \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredTravelerType) {
                throw new \InvalidArgumentException(sprintf('The coveredTraveler property can only contain items of \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredTravelerType, "%s" given', is_object($coveredTravelersTypeCoveredTravelerItem) ? get_class($coveredTravelersTypeCoveredTravelerItem) : gettype($coveredTravelersTypeCoveredTravelerItem)), __LINE__);
            }
        }
        $this->coveredTraveler = $coveredTraveler;
        return $this;
    }
    /**
     * Add item to coveredTraveler value
     * @throws \InvalidArgumentException
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredTravelerType $item
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredTravelersType
     */
    public function addToCoveredTraveler(\Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredTravelerType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredTravelerType) {
            throw new \InvalidArgumentException(sprintf('The coveredTraveler property can only contain items of \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredTravelerType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->coveredTraveler[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredTravelersType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
