<?php

namespace Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for indCoverageType StructType
 * Meta informations extracted from the WSDL
 * - documentation: Enthält individuelle reisespezifische Informationen. | Contains identifying information as well as coverage requirements and journey information for each individual.
 * @subpackage Structs
 */
class IndCoverageType extends AbstractStructBase
{
    /**
     * The tripCost
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\TripCost
     */
    public $tripCost;
    /**
     * The coveredLuggage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredLuggage
     */
    public $coveredLuggage;
    /**
     * Constructor method for indCoverageType
     * @uses IndCoverageType::setTripCost()
     * @uses IndCoverageType::setCoveredLuggage()
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\TripCost $tripCost
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredLuggage $coveredLuggage
     */
    public function __construct(\Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\TripCost $tripCost = null, \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredLuggage $coveredLuggage = null)
    {
        $this
            ->setTripCost($tripCost)
            ->setCoveredLuggage($coveredLuggage);
    }
    /**
     * Get tripCost value
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\TripCost|null
     */
    public function getTripCost()
    {
        return $this->tripCost;
    }
    /**
     * Set tripCost value
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\TripCost $tripCost
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\IndCoverageType
     */
    public function setTripCost(\Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\TripCost $tripCost = null)
    {
        $this->tripCost = $tripCost;
        return $this;
    }
    /**
     * Get coveredLuggage value
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredLuggage|null
     */
    public function getCoveredLuggage()
    {
        return $this->coveredLuggage;
    }
    /**
     * Set coveredLuggage value
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredLuggage $coveredLuggage
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\IndCoverageType
     */
    public function setCoveredLuggage(\Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\CoveredLuggage $coveredLuggage = null)
    {
        $this->coveredLuggage = $coveredLuggage;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\IndCoverageType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
