<?php

namespace Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for insConditionsRqType StructType
 * Meta informations extracted from the WSDL
 * - documentation: type for insurance conditions [Typ fuer Versicherungsbedingungen]
 * @subpackage Structs
 */
class InsConditionsRqType extends AbstractStructBase
{
    /**
     * The agreed
     * @var string
     */
    public $agreed;
    /**
     * Constructor method for insConditionsRqType
     * @uses InsConditionsRqType::setAgreed()
     * @param string $agreed
     */
    public function __construct($agreed = null)
    {
        $this
            ->setAgreed($agreed);
    }
    /**
     * Get agreed value
     * @return string|null
     */
    public function getAgreed()
    {
        return $this->agreed;
    }
    /**
     * Set agreed value
     * @uses \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\EnumType\Agreed::valueIsValid()
     * @uses \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\EnumType\Agreed::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $agreed
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\InsConditionsRqType
     */
    public function setAgreed($agreed = null)
    {
        // validation for constraint: enumeration
        if (!\Sio\Module\TourismInsuranceBundle\Model\ErvSoap\EnumType\Agreed::valueIsValid($agreed)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $agreed, implode(', ', \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\EnumType\Agreed::getValidValues())), __LINE__);
        }
        $this->agreed = $agreed;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\InsConditionsRqType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
