<?php

namespace Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for offersRpType StructType
 * Meta informations extracted from the WSDL
 * - documentation: type for offer [Typ fuer Angebot]
 * @subpackage Structs
 */
class OffersRpType extends AbstractStructBase
{
    /**
     * The offer
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\Offer[]
     */
    public $offer;
    /**
     * Constructor method for offersRpType
     * @uses OffersRpType::setOffer()
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\Offer[] $offer
     */
    public function __construct(array $offer = array())
    {
        $this
            ->setOffer($offer);
    }
    /**
     * Get offer value
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\Offer[]|null
     */
    public function getOffer()
    {
        return $this->offer;
    }
    /**
     * Set offer value
     * @throws \InvalidArgumentException
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\Offer[] $offer
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\OffersRpType
     */
    public function setOffer(array $offer = array())
    {
        foreach ($offer as $offersRpTypeOfferItem) {
            // validation for constraint: itemType
            if (!$offersRpTypeOfferItem instanceof \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\Offer) {
                throw new \InvalidArgumentException(sprintf('The offer property can only contain items of \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\Offer, "%s" given', is_object($offersRpTypeOfferItem) ? get_class($offersRpTypeOfferItem) : gettype($offersRpTypeOfferItem)), __LINE__);
            }
        }
        $this->offer = $offer;
        return $this;
    }
    /**
     * Add item to offer value
     * @throws \InvalidArgumentException
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\Offer $item
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\OffersRpType
     */
    public function addToOffer(\Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\Offer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\Offer) {
            throw new \InvalidArgumentException(sprintf('The offer property can only contain items of \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\Offer, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->offer[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\OffersRpType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
