<?php

namespace Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for policyAsLink StructType
 * Meta informations extracted from the WSDL
 * - documentation: Policy pdf Link senden | send policy pdf link
 * @subpackage Structs
 */
class PolicyAsLink extends AbstractStructBase
{
    /**
     * The sendLink
     * @var bool
     */
    public $sendLink;
    /**
     * The sendAdditionalEmail
     * @var bool
     */
    public $sendAdditionalEmail;
    /**
     * Constructor method for policyAsLink
     * @uses PolicyAsLink::setSendLink()
     * @uses PolicyAsLink::setSendAdditionalEmail()
     * @param bool $sendLink
     * @param bool $sendAdditionalEmail
     */
    public function __construct($sendLink = null, $sendAdditionalEmail = null)
    {
        $this
            ->setSendLink($sendLink)
            ->setSendAdditionalEmail($sendAdditionalEmail);
    }
    /**
     * Get sendLink value
     * @return bool|null
     */
    public function getSendLink()
    {
        return $this->sendLink;
    }
    /**
     * Set sendLink value
     * @param bool $sendLink
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\PolicyAsLink
     */
    public function setSendLink($sendLink = null)
    {
        // validation for constraint: boolean
        if (!is_null($sendLink) && !is_bool($sendLink)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($sendLink)), __LINE__);
        }
        $this->sendLink = $sendLink;
        return $this;
    }
    /**
     * Get sendAdditionalEmail value
     * @return bool|null
     */
    public function getSendAdditionalEmail()
    {
        return $this->sendAdditionalEmail;
    }
    /**
     * Set sendAdditionalEmail value
     * @param bool $sendAdditionalEmail
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\PolicyAsLink
     */
    public function setSendAdditionalEmail($sendAdditionalEmail = null)
    {
        // validation for constraint: boolean
        if (!is_null($sendAdditionalEmail) && !is_bool($sendAdditionalEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($sendAdditionalEmail)), __LINE__);
        }
        $this->sendAdditionalEmail = $sendAdditionalEmail;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\PolicyAsLink
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
