<?php

namespace Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for searchTravelerType StructType
 * @subpackage Structs
 */
class SearchTravelerType extends AbstractStructBase
{
    /**
     * The id
     * Meta informations extracted from the WSDL
     * - documentation: Eindeutiger Identifier | Unique identifier
     * - use: required
     * @var int
     */
    public $id;
    /**
     * The birthdate
     * Meta informations extracted from the WSDL
     * - documentation: Geburtsdatum | Birthdate
     * @var string
     */
    public $birthdate;
    /**
     * The age
     * Meta informations extracted from the WSDL
     * - documentation: Alter | Age
     * @var int
     */
    public $age;
    /**
     * The indCoverage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\IndCoverageType
     */
    public $indCoverage;
    /**
     * Constructor method for searchTravelerType
     * @uses SearchTravelerType::setId()
     * @uses SearchTravelerType::setBirthdate()
     * @uses SearchTravelerType::setAge()
     * @uses SearchTravelerType::setIndCoverage()
     * @param int $id
     * @param string $birthdate
     * @param int $age
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\IndCoverageType $indCoverage
     */
    public function __construct($id = null, $birthdate = null, $age = null, \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\IndCoverageType $indCoverage = null)
    {
        $this
            ->setId($id)
            ->setBirthdate($birthdate)
            ->setAge($age)
            ->setIndCoverage($indCoverage);
    }
    /**
     * Get id value
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param int $id
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\SearchTravelerType
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !is_numeric($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get birthdate value
     * @return string|null
     */
    public function getBirthdate()
    {
        return $this->birthdate;
    }
    /**
     * Set birthdate value
     * @param string $birthdate
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\SearchTravelerType
     */
    public function setBirthdate($birthdate = null)
    {
        // validation for constraint: string
        if (!is_null($birthdate) && !is_string($birthdate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($birthdate)), __LINE__);
        }
        $this->birthdate = $birthdate;
        return $this;
    }
    /**
     * Get age value
     * @return int|null
     */
    public function getAge()
    {
        return $this->age;
    }
    /**
     * Set age value
     * @param int $age
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\SearchTravelerType
     */
    public function setAge($age = null)
    {
        // validation for constraint: int
        if (!is_null($age) && !is_numeric($age)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($age)), __LINE__);
        }
        $this->age = $age;
        return $this;
    }
    /**
     * Get indCoverage value
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\IndCoverageType|null
     */
    public function getIndCoverage()
    {
        return $this->indCoverage;
    }
    /**
     * Set indCoverage value
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\IndCoverageType $indCoverage
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\SearchTravelerType
     */
    public function setIndCoverage(\Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\IndCoverageType $indCoverage = null)
    {
        $this->indCoverage = $indCoverage;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\SearchTravelerType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
