<?php

namespace Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for systemRqType StructType
 * Meta informations extracted from the WSDL
 * - documentation: type for exi system data [Typ fuer Systeminformationen]
 * @subpackage Structs
 */
class SystemRqType extends AbstractStructBase
{
    /**
     * The testIdentifier
     * Meta informations extracted from the WSDL
     * - documentation: Test/Production identifier [Kennzeichen ob Test oder Produktion]
     * @var bool
     */
    public $testIdentifier;
    /**
     * The localisation
     * Meta informations extracted from the WSDL
     * - documentation: locale informations [Laenderinformationen]
     * @var \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\LocalisationType
     */
    public $localisation;
    /**
     * The version
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $version;
    /**
     * Constructor method for systemRqType
     * @uses SystemRqType::setTestIdentifier()
     * @uses SystemRqType::setLocalisation()
     * @uses SystemRqType::setVersion()
     * @param bool $testIdentifier
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\LocalisationType $localisation
     * @param string $version
     */
    public function __construct($testIdentifier = null, \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\LocalisationType $localisation = null, $version = null)
    {
        $this
            ->setTestIdentifier($testIdentifier)
            ->setLocalisation($localisation)
            ->setVersion($version);
    }
    /**
     * Get testIdentifier value
     * @return bool|null
     */
    public function getTestIdentifier()
    {
        return $this->testIdentifier;
    }
    /**
     * Set testIdentifier value
     * @param bool $testIdentifier
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\SystemRqType
     */
    public function setTestIdentifier($testIdentifier = null)
    {
        // validation for constraint: boolean
        if (!is_null($testIdentifier) && !is_bool($testIdentifier)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($testIdentifier)), __LINE__);
        }
        $this->testIdentifier = $testIdentifier;
        return $this;
    }
    /**
     * Get localisation value
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\LocalisationType|null
     */
    public function getLocalisation()
    {
        return $this->localisation;
    }
    /**
     * Set localisation value
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\LocalisationType $localisation
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\SystemRqType
     */
    public function setLocalisation(\Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\LocalisationType $localisation = null)
    {
        $this->localisation = $localisation;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\SystemRqType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\SystemRqType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
