<?php

namespace Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for userErrorType StructType
 * Meta informations extracted from the WSDL
 * - documentation: type for an error [Typ fuer einen Fehleraufbau]
 * @subpackage Structs
 */
class UserErrorType extends AbstractStructBase
{
    /**
     * The error
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\ErrorType[]
     */
    public $error;
    /**
     * Constructor method for userErrorType
     * @uses UserErrorType::setError()
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\ErrorType[] $error
     */
    public function __construct(array $error = array())
    {
        $this
            ->setError($error);
    }
    /**
     * Get error value
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\ErrorType[]|null
     */
    public function getError()
    {
        return $this->error;
    }
    /**
     * Set error value
     * @throws \InvalidArgumentException
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\ErrorType[] $error
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\UserErrorType
     */
    public function setError(array $error = array())
    {
        foreach ($error as $userErrorTypeErrorItem) {
            // validation for constraint: itemType
            if (!$userErrorTypeErrorItem instanceof \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\ErrorType) {
                throw new \InvalidArgumentException(sprintf('The error property can only contain items of \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\ErrorType, "%s" given', is_object($userErrorTypeErrorItem) ? get_class($userErrorTypeErrorItem) : gettype($userErrorTypeErrorItem)), __LINE__);
            }
        }
        $this->error = $error;
        return $this;
    }
    /**
     * Add item to error value
     * @throws \InvalidArgumentException
     * @param \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\ErrorType $item
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\UserErrorType
     */
    public function addToError(\Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\ErrorType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\ErrorType) {
            throw new \InvalidArgumentException(sprintf('The error property can only contain items of \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\ErrorType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->error[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sio\Module\TourismInsuranceBundle\Model\ErvSoap\StructType\UserErrorType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
